{ Unit otte_ctype contains system-dependant parts of OTTE. Namely, it provides
  OTTE witch basic charset routines, used for case-insensivity purposes.
  This sysalpha unit was written for linux and is GNU libc dependant.
------------------------------------------------------------------------------}
unit otte_ctype;

{$I otte_cfg.pas}

interface //===================================================================

function getlocale: ansistring;
function setlocale(const locale: ansistring): boolean;
function isalpha(c: char): boolean;
function tolower(c: char): char;

implementation //==============================================================

const LC_CTYPE = 0;

{$LINKLIB c}
function c_setlocale(category: longint; locale: pchar): pchar; cdecl; external name 'setlocale';
function c_isalpha(c: longint): longint; cdecl; external name 'isalpha';
function c_tolower(c: longint): longint; cdecl; external name 'tolower';

//-----------------------------------------------------------------------------
function getlocale: ansistring;
begin
  getlocale := c_setlocale(LC_CTYPE, nil);
end;

//-----------------------------------------------------------------------------
function setlocale(const locale: ansistring): boolean;
begin
  setlocale := c_setlocale(LC_CTYPE, pchar(locale)) <> nil;
end;

//-----------------------------------------------------------------------------
function isalpha(c: char): boolean;
begin
  isalpha := c_isalpha(byte(c)) <> 0;
end;

//-----------------------------------------------------------------------------
function tolower(c: char): char;
begin
  tolower := char(c_tolower(byte(c)));
end;

begin
  setlocale('');
end.
